extends Node2D

export (PackedScene) var Mob

const MIN_SPAWN_TIME := 0.8

var spawn_rect_size := Vector2()
var prev := 0

onready var score := $HUD/Score
onready var player := $Player
onready var camera := $Player/Camera2D
onready var spawnTimer := $MobTimer

func _ready():
	randomize()

func _process(_delta: float):
	var player_army := get_tree().get_nodes_in_group(player.GROUP)
	var army_strength := len(player_army)
	if army_strength == prev:
		return
	
	score.text = str(army_strength - 1)
	spawnTimer.wait_time = MIN_SPAWN_TIME + 0.3 / army_strength
	prev = army_strength
	
func _on_MobTimer_timeout():
	var orientation := (randi() % 2 - 0.5) * 2
	var edge := orientation * spawn_rect_size
	var axis_toggle := randi() % 2
	var abs_side := Vector2(spawn_rect_size.x * axis_toggle, spawn_rect_size.y * (1-axis_toggle))
	var side := -orientation * abs_side
	var pos_on_side := side * randf() * 2.0
	var screen_center: Vector2 = camera.get_camera_screen_center()
	var spawn_pos = screen_center + edge + pos_on_side
	var mob: RigidBody2D = Mob.instance()
	add_child(mob)
	mob.global_position = spawn_pos * camera.zoom

func _draw():
	spawn_rect_size = get_viewport_rect().size / 1.7